<template>
  <div class="app-container">
    <el-form
      v-show="showSearch"
      ref="queryRef"
      :inline="true"
      :model="queryParams"
      label-position="left"
      label-width="100px"
      @submit.prevent
    >
      <!--      <el-form-item label="父ID" prop="parentId">-->
      <!--        <el-input-->
      <!--          v-model="queryParams.parentId"-->
      <!--          clearable-->
      <!--          placeholder="请输入父ID"-->
      <!--          @keyup.enter="handleQuery"-->
      <!--        />-->
      <!--      </el-form-item>-->
      <el-form-item label="物品分类名称" prop="name">
        <el-input
          v-model="queryParams.name"
          clearable
          placeholder="请输入物品分类名称"
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <!--      <el-form-item label="排序" prop="sort">-->
      <!--        <el-input-->
      <!--          v-model="queryParams.sort"-->
      <!--          clearable-->
      <!--          placeholder="请输入排序"-->
      <!--          @keyup.enter="handleQuery"-->
      <!--        />-->
      <!--      </el-form-item>-->
      <!--      <el-form-item label="租户ID" prop="tenantId">-->
      <!--        <el-input-->
      <!--          v-model="queryParams.tenantId"-->
      <!--          clearable-->
      <!--          placeholder="请输入租户ID"-->
      <!--          @keyup.enter="handleQuery"-->
      <!--        />-->
      <!--      </el-form-item>-->
      <el-form-item>
        <el-button icon="Search" type="primary" @click="handleQuery"
          >搜索
        </el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['product:category:add']"
          icon="Plus"
          plain
          type="primary"
          @click="handleAdd()"
          >新增
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['product:category:edit']"
          :disabled="single"
          icon="Edit"
          plain
          type="success"
          @click="handleUpdate"
          >修改
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['product:category:remove']"
          :disabled="multiple"
          icon="Delete"
          plain
          type="danger"
          @click="handleDelete"
          >删除
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['product:category:export']"
          icon="Download"
          plain
          type="warning"
          @click="handleExport"
          >导出
        </el-button>
      </el-col>
      <right-toolbar
        v-model:showSearch="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="categoryList"
      :tree-props="{ children: 'children' }"
      row-key="categoryId"
      @selection-change="handleSelectionChange"
    >
      <el-table-column align="center" type="selection" width="55" />
      <!--      <el-table-column align="center" label="物品分类ID" prop="categoryId" />-->
      <!--      <el-table-column align="center" label="父ID" prop="parentId" />-->
      <el-table-column align="center" label="物品分类名称" prop="name" />
      <!--      <el-table-column align="center" label="排序" prop="sort" />-->
      <el-table-column align="center" label="备注" prop="remark" />
      <!--      <el-table-column align="center" label="状态(0正常1禁用)" prop="status" />-->
      <!--      <el-table-column align="center" label="租户ID" prop="tenantId" />-->
      <el-table-column
        align="center"
        class-name="small-padding fixed-width"
        label="操作"
      >
        <template #default="scope">
          <el-button
            v-hasPermi="['product:category:edit']"
            icon="Edit"
            link
            type="warning"
            @click="handleUpdate(scope.row)"
            >修改
          </el-button>
          <el-button
            v-hasPermi="['product:category:remove']"
            icon="Delete"
            link
            type="danger"
            @click="handleDelete(scope.row)"
            >删除
          </el-button>
          <el-button
            v-hasPermi="['product:category:add']"
            icon="Plus"
            link
            type="primary"
            @click="handleAdd(scope.row.categoryId)"
            >添加子节点
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <!--    <pagination-->
    <!--      v-show="total>0"-->
    <!--      v-model:limit="queryParams.pageSize"-->
    <!--      v-model:page="queryParams.pageNum"-->
    <!--      :total="total"-->
    <!--      @pagination="getList"-->
    <!--    />-->

    <!-- 添加或修改产品分类对话框 -->
    <el-dialog v-model="open" :title="title" append-to-body width="500px">
      <el-form
        ref="categoryRef"
        :model="form"
        :rules="rules"
        label-position="left"
        label-width="120px"
      >
        <el-form-item label="物品分类名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入物品分类名称" />
        </el-form-item>
        <el-form-item label="选择上级" prop="parentId">
          <!--                  <el-input v-model="form.parentId" placeholder="请输入父ID" />-->
          <el-tree-select
            v-model="form.parentId"
            :data="[
              {
                categoryId: 0,
                name: '根节点',
                children: categoryList,
              },
            ]"
            :default-expanded-keys="[form.parentId]"
            :props="{
              value: 'categoryId',
              label: 'name',
              children: 'children',
            }"
            check-strictly
            node-key="categoryId"
            placeholder="选择上级分类"
            value-key="categoryId"
          />
        </el-form-item>
        <!--        <el-form-item label="排序" prop="sort">-->
        <!--          <el-input v-model="form.sort" placeholder="请输入排序" />-->
        <!--        </el-form-item>-->
        <el-form-item label="备注" prop="remark">
          <el-input
            v-model="form.remark"
            placeholder="请输入内容"
            type="textarea"
          />
        </el-form-item>
        <!--        <el-form-item label="租户ID" prop="tenantId">-->
        <!--          <el-input v-model="form.tenantId" placeholder="请输入租户ID" />-->
        <!--        </el-form-item>-->
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script name="Category" setup>
import {
  addCategory,
  delCategory,
  getCategory,
  listCategory,
  updateCategory,
} from "@/api/product/category";
import { getCurrentInstance, reactive, ref, toRefs } from "vue";

const { proxy } = getCurrentInstance();

const categoryList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const data = reactive({
  form: {},
  queryParams: {
    // pageNum: 1,
    // pageSize: 10,
    parentId: null,
    name: null,
    sort: null,
    status: null,
    tenantId: null,
  },
  rules: {
    name: [{ required: true, message: "请输入产品分类名称", trigger: "blur" }],
  },
});

const { queryParams, form, rules } = toRefs(data);

/** 查询产品分类列表 */
function getList() {
  loading.value = true;
  listCategory(queryParams.value).then((response) => {
    categoryList.value = response.data;
    // total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    categoryId: null,
    parentId: 0,
    name: null,
    sort: null,
    remark: null,
    createTime: null,
    createBy: null,
    status: null,
    tenantId: null,
  };
  proxy.resetForm("categoryRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  // queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map((item) => item.categoryId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd(categoryId) {
  reset();
  if (categoryId) {
    form.value.parentId = categoryId;
  }
  open.value = true;
  title.value = "添加产品分类";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _categoryId = row.categoryId || ids.value;
  getCategory(_categoryId).then((response) => {
    form.value = response.data;
    open.value = true;
    title.value = "修改产品分类";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["categoryRef"].validate((valid) => {
    if (valid) {
      if (form.value.categoryId != null) {
        updateCategory(form.value).then((response) => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addCategory(form.value).then((response) => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _categoryIds = row.categoryId || ids.value;
  proxy.$modal
    .confirm('是否确认删除产品分类编号为"' + _categoryIds + '"的数据项？')
    .then(function () {
      return delCategory(_categoryIds);
    })
    .then(() => {
      getList();
      proxy.$modal.msgSuccess("删除成功");
    })
    .catch(() => {});
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download(
    "product/category/export",
    {
      ...queryParams.value,
    },
    `category_${new Date().getTime()}.xlsx`
  );
}

getList();
</script>
